// =====================================================================
/*!
//
//  \file TOutputObjectFile.hh
//  \brief This file contains the TOutputObjectFile class.
//  \author Go IWAI <goiwai@users.sourceforge.jp>
//
//  $Id: TOutputObjectFile.hh,v 1.4 2003/11/03 08:35:13 goiwai Exp $
//  $Name: CLDAQ-1-10-00 $
//  $Log: TOutputObjectFile.hh,v $
//  Revision 1.4  2003/11/03 08:35:13  goiwai
//  DoxygenѤΥȥȤ򤦤Ǥߤ򳫻Ϥޤ.
//
//  Revision 1.3  2003/10/06 17:02:42  goiwai
//  *** empty log message ***
//
//  Revision 1.2  2003/07/30 16:19:31  goiwai
//  ե˥ߥåȥĤ뤳Ȥˤޤ.
//
*/
// =====================================================================
#ifndef __TOUTPUTOBJECTFILE_HH
#define __TOUTPUTOBJECTFILE_HH

#include "Tglobals.h"
#include "TObjectFile.hh"
#include "TStreamableObject.hh"
#include "TOutputObjectStream.hh"

class TStreamableObject;
class TObjectFilter;


/*!
// \example
//
// If example code exists.
//
*/

/*!
// \class TOutputObjectFile
// \brief This is the TOutputObjectFile class.
// \author Go IWAI <goiwai@users.sourceforge.jp>
//
// The TOutputObjectFile class detail description.
// Write it down ASAP!
//
// \todo None?
// \bug None?
// \ingroup PersistencyCategory
*/
class TOutputObjectFile
  : public TObjectFile, public TOutputObjectStream
{

  public:
    TOutputObjectFile( const Tstring& filename, const Tstring& mode = "w" );
    TOutputObjectFile( TObjectFilter* filter, const Tstring& filename, const Tstring& mode = "w" );
    ~TOutputObjectFile();

  public:
    Tint Write( TStreamableObject& object );

};

#endif
